
function toFloat(v) {
    return parseFloat(v.replace(',', '.'));
}

function id(name) {
    return document.getElementById(name);
}

function floatValue(name) {
    return toFloat(document.getElementById(name).value);
}

function round(expr, decimals) {
    p = Math.pow(10, decimals);
    return Math.round(expr*p)/p;
}

function setReadOnly(name, b) {
    if(b) {
        document.getElementById(name).setAttribute("readonly","readonly");
    } else {
        document.getElementById(name).removeAttribute("readonly");
    }
}

function calcradcopper() {
    if(id('rtamb').checked) {
        setReadOnly('tamb', true);setReadOnly('pd', false);setReadOnly('aire', false);
        id('tamb').value = round(floatValue('tmax')-(floatValue('pd')*(floatValue('rsa')/floatValue('aire')+floatValue('rjs'))), 1);
    } else if(id('rpd').checked) {
        setReadOnly('tamb', false);setReadOnly('pd', true);setReadOnly('aire', false);
        id('pd').value = round((floatValue('tmax')-floatValue('tamb'))/(floatValue('rsa')/floatValue('aire')+floatValue('rjs')), 3);
    } else if(id('raire').checked) {
        setReadOnly('tamb', false);setReadOnly('pd', false);setReadOnly('aire', true);
        id('aire').value = round(floatValue('pd')*floatValue('rsa')/(floatValue('tmax')-floatValue('tamb')-floatValue('pd')*floatValue('rjs')), 1);
    }
}

function calcpcbtrace() {
    var i = floatValue('courant');
    var ep = floatValue('epaisseur')*1e-4;//cm
    var tamb = floatValue('tamb');
    var trise = floatValue('trise');
    var longueur = floatValue('longueur')*0.1;//cm
    var interne = document.getElementById('interne').checked;
	
	var k = 0.048;
	if(interne === true)
		k = 0.024;
	//1 mils <-> 0.0254 mm = 0.00254cm = 2.54e-3 cm
	var area = Math.pow((i/(k*Math.pow(trise, 0.44))), 1/0.725);
	area=area*2.54*2.54/1e6; //mil^2 to cm^2
	var width = area*10/ep;//mm
	
	var rcu=1.7e-6;//Res du cuivre (ohm.cm)
	var tcoef=3.9e-3;//Temp res coef (ohm/ohm/C)
	var res = (rcu*longueur/area)*(1+tcoef*((tamb+trise)-25))*1000;//mohms
	var u = res*i;//mV
	var power = i*u;//mW
	
	id('largeur').value = round(width, 3);
	id('valres').innerHTML = round(res, 3)+' m&#8486;';
	id('valu').innerHTML = round(u, 3)+' mV';
	id('valp').innerHTML = round(power, 3)+' mW';
}

function calcpcbtrace_() {
    var width = floatValue('largeur');//mm
    var ep = floatValue('epaisseur')*1e-4;//cm
    var tamb = floatValue('tamb');
    var trise = floatValue('trise');
    var longueur = floatValue('longueur')*0.1;//cm
    var interne = document.getElementById('interne').checked;
	
	var k = 0.048;
	if(interne === true)
		k = 0.024;
	
	var area = width*ep/10;
	area = area*1e6/(2.54*2.54);
	var i = k*Math.pow(area, 0.725)*Math.pow(trise, 0.44);
	
	area=area*2.54*2.54/1e6;
	
	var rcu=1.7e-6;//Res du cuivre (ohm.cm)
	var tcoef=3.9e-3;//Temp res coef (ohm/ohm/C)
	var res = (rcu*longueur/area)*(1+tcoef*((tamb+trise)-25))*1000;//mohms
	var u = res*i;//mV
	var power = i*u;//mW
	
	id('courant').value = round(i, 2);
	id('valres').innerHTML = round(res, 3)+' m&#8486;';
	id('valu').innerHTML = round(u, 3)+' mV';
	id('valp').innerHTML = round(power, 3)+' mW';
}

function calcsr() {
    if(id('rmcd').checked) {
        setReadOnly('mcd', true);setReadOnly('deg', false);setReadOnly('lm', false);
        id('mcd').value = round(floatValue('lm')/(2*Math.PI*(1-Math.cos(floatValue('deg')/360*Math.PI)))*1000, 0);
    } else if(id('rdeg').checked) {
        setReadOnly('mcd', false);setReadOnly('deg', true);setReadOnly('lm', false);
        id('deg').value = round(Math.acos(1-floatValue('lm')/(floatValue('mcd')*0.002*Math.PI))*360/Math.PI, 1);
    } else if(id('rlm').checked) {
        setReadOnly('mcd', false);setReadOnly('deg', false);setReadOnly('lm', true);
        id('lm').value = round(floatValue('mcd')*0.001*2*Math.PI*(1-Math.cos(floatValue('deg')/360*Math.PI)), 3);
    }
}


function resToString(r, decimals) {
    if(r < 1000) {
        return round(r, decimals)+'&#8486;';
    } else {
        r = r/1000;
        if(r < 1000) {
            return round(r, decimals)+'k&#8486;';
        } else {
            r = r/1000;
            return round(r, decimals)+'M&#8486;';
        }
    }
}

function calclm317uout() {
/*
Uout = 1.25*(1+R2/R1) + I*R2
Uout/1.25 -1 = R2/R1 + I/1.25*R2
R2(1/R1 + I/1.25) = Uout/1.25-1
*/

	var r1Id = 'r1';
	var r2Id = 'r2';
	if(id('gnd').checked) {
		r1Id = 'r2';
		r2Id = 'r1';
	}

    var uref = floatValue('uref');
    var u = floatValue('uout');
    var iadj = floatValue('ia')*0.001*0.001/uref;
    
    var eX, cnt=12;
    if(id('e12').checked) {
        eX = [100, 120, 150, 180, 220, 270, 330, 390, 470, 560, 680, 820];//E12
    } else {
        eX = [100, 110, 120, 130, 150, 160, 180, 200, 220, 240, 270, 300, 330, 360, 390, 430, 470, 510, 560, 620, 680, 750, 820, 910];//E24
        cnt = 24;
    }
    var values = [];
    var dk=1;
    for(var k=0;k<=3;) {
        for(var i=0;i<cnt;i++) {
            values.push(eX[i]*Math.pow(10, k));
        }
        if(k==0) {
            k=-1;
        } else if(k==-1) {
            k=1;
        } else {
            k++;
        }
    }
    
    var prc=1000, ir1=0, ir2=0;;
    var ratio = u/uref-1.0;
    
    for(var i=0, l=values.length;i<l;i++) {
        for(var i2=0;i2<l;i2++) {
            var rr = values[i2]*((1/values[i])+iadj);
            var p = Math.abs(rr-ratio);
            if(p<prc && Math.abs(p-prc) >= 0.01) {
                prc = p;
                ir1 = i;
                ir2 = i2;
                if(p == 0) {
                    i = l;
                    i2 = l;
                }
            }
        }
    }
    
    r = values[ir1];
    if(r < 1000) {
        document.getElementById(r1Id).value = r;document.getElementById('unite1').value = 0;
    } else {
        r = r/1000;
        document.getElementById(r1Id).value = r;document.getElementById('unite1').value = 3;
    }
    r = values[ir2];
    if(r < 1000) {
        document.getElementById(r2Id).value = r;document.getElementById('unite2').value = 0;
    } else {
        r = r/1000;
        document.getElementById(r2Id).value = r;document.getElementById('unite2').value = 3;
    }
}

function calclm317() {
	var r1Id = 'r1';
	var r2Id = 'r2';
	if(id('gnd').checked) {
		r1Id = 'r2';
		r2Id = 'r1';
	}
	
    var uref = floatValue('uref');
	var r1 = toFloat(document.getElementById(r1Id).value)*Math.pow(10, parseInt(document.getElementById('unite1').value));
	var r2 = toFloat(document.getElementById(r2Id).value)*Math.pow(10, parseInt(document.getElementById('unite2').value));
    
	//alert(uref+", "+r1+", "+r2+", "+uref*(1.0+r2/r1));
    id('uout').value = round(uref*(1.0+r2/r1)+floatValue('ia')*0.001*0.001*r2, 3);
}

function calcdv() {
//alert('a');
    if(id('rc').checked) {
        setReadOnly('c', true);setReadOnly('i', false);setReadOnly('dv', false);setReadOnly('f', false);
        id('c').value = round(floatValue('i')*1e6/(floatValue('dv')*floatValue('f')), 0);
    } else if(id('ri').checked) {
        setReadOnly('c', false);setReadOnly('i', true);setReadOnly('dv', false);setReadOnly('f', false);
        id('i').value = round(floatValue('c')*1e-6*floatValue('dv')*floatValue('f'), 3);
    } else if(id('rdv').checked) {
        setReadOnly('c', false);setReadOnly('i', false);setReadOnly('dv', true);setReadOnly('f', false);
        id('dv').value = round(floatValue('i')/(floatValue('c')*floatValue('f')*1e-6), 3);
    } else if(id('rf').checked) {
        setReadOnly('c', false);setReadOnly('i', false);setReadOnly('dv', false);setReadOnly('f', true);
        id('f').value = round(floatValue('i')/(floatValue('dv')*floatValue('c')*1e-6), 3);
    }
//alert('z');
}

function calcbipcomres() {
    var res = (floatValue('ucom')-floatValue('uchute'))*floatValue('gain')*1000/floatValue('i');
    id('result').innerHTML = resToString(res, 2);
    
    var eX, cnt=12;
    if(id('e12').checked) {
        eX = [100, 120, 150, 180, 220, 270, 330, 390, 470, 560, 680, 820];//E12
    } else {
        eX = [100, 110, 120, 130, 150, 160, 180, 200, 220, 240, 270, 300, 330, 360, 390, 430, 470, 510, 560, 620, 680, 750, 820, 910];//E24
        cnt = 24;
    }
    var values = [];
    for(var k=3;k>=-2;k--) {
        for(var i=0;i<cnt;i++) {
            values.push(eX[i]*Math.pow(10, k));
        }
    }
    
    var prc=1000, ir1=0;
    var ratio = res/2;
    for(var i=0, l=values.length;i<l;i++) {
        var p = Math.abs(values[i]-ratio);
        if(p<prc) {
            prc = p;
            ir1 = i;
            if(p == 0)
                break;
        }
    }
    
    id('result2').innerHTML = resToString(values[ir1], 2);
}

function calcpd() {
    if(id('rupd').checked) {
        id('upd').value = round(floatValue('pd')/floatValue('ipd'), 3);
    } else if(id('ripd').checked) {
        id('ipd').value = round(floatValue('pd')/floatValue('upd'), 3);
    } else {
        id('pd').value = round(floatValue('upd')*floatValue('ipd'), 3);
    }
    calcrad();
}

function calcupd() {
    id('ipd').value = round(floatValue('pd')/floatValue('upd'), 3);
    calcrad();
}

function calcrad()
{
    if(id('rtamb').checked) {
        setReadOnly('tamb', true);setReadOnly('rthrad', false);setReadOnly('pd', false);setReadOnly('ipd', false);setReadOnly('upd', false);
        id('tamb').value = round(floatValue('tmax')-floatValue('pd')*(floatValue('rthint')+floatValue('rthrad')), 1);
    } else if(id('rrthrad').checked) {
        setReadOnly('tamb', false);setReadOnly('rthrad', true);setReadOnly('pd', false);setReadOnly('ipd', false);setReadOnly('upd', false);
        id('rthrad').value = round((floatValue('tmax')-floatValue('tamb'))/floatValue('pd')-floatValue('rthint'), 1);
    } else if(id('rpd').checked) {
        setReadOnly('tamb', false);setReadOnly('rthrad', false);setReadOnly('pd', true);setReadOnly('ipd', true);setReadOnly('upd', true);
        id('pd').value = round((floatValue('tmax')-floatValue('tamb'))/(floatValue('rthrad')+floatValue('rthint')), 3);
        id('ipd').value = round((floatValue('pd')/floatValue('upd')), 3);
    } else if(id('ripd').checked) {
        setReadOnly('tamb', false);setReadOnly('rthrad', false);setReadOnly('pd', false);setReadOnly('ipd', true);setReadOnly('upd', false);
        id('ipd').value = round((floatValue('tmax')-floatValue('tamb'))/((floatValue('rthrad')+floatValue('rthint'))*floatValue('upd')), 3);
        id('pd').value = round(floatValue('upd')*floatValue('ipd'), 3);
    } else if(id('rupd').checked) {
        setReadOnly('tamb', false);setReadOnly('rthrad', false);setReadOnly('pd', false);setReadOnly('ipd', false);setReadOnly('upd', true);
        id('upd').value = round((floatValue('tmax')-floatValue('tamb'))/((floatValue('rthrad')+floatValue('rthint'))*floatValue('ipd')), 3);
        id('pd').value = round(floatValue('upd')*floatValue('ipd'), 3);
    }
}

function calcpdiv()
{
    var r1 = toFloat(document.getElementById('r1').value)*Math.pow(10, parseInt(document.getElementById('unite1').value));
    var r2 = toFloat(document.getElementById('r2').value)*Math.pow(10, parseInt(document.getElementById('unite2').value));
    var ualim = toFloat(document.getElementById('ualim').value);
    
    document.getElementById('uout').value = Math.round(r2*ualim*100/(r1+r2))/100;
}

function calcpdivinv()
{
/*
Uout/Uin = R2/(R1+R2) = R2/(R2*(1+R1/R2))= 1/(1+R1/R2)
Uin/Uout = R1/R2+1
Uin/Uout-1 = R1/R2
*/
    var ratio = toFloat(document.getElementById('ualim').value)/toFloat(document.getElementById('uout').value)-1;
    var e24 = [100, 110, 120, 130, 150, 160, 180, 200, 220, 240, 270, 300, 330, 360, 390, 430, 470, 510, 560, 620, 680, 750, 820, 910];//E24
    var values = [];
    for(var k=3;k>=-2;k--) {
        for(var i=0;i<24;i++) {
            values.push(e24[i]*Math.pow(10, k));
        }
    }
    
    var prc=1000, ir1=0, ir2=0;
    /*var imax, imin;
    for(var i=0, l=values.length;i<l;i++) {
        imax = l-1;
        imin=0;
        while(imax-imin > 3) {
            var ra = values[Math.round((imax-imin)/2)]/values[i];
            //alert(ra+'/'+ratio+' - '+imin+', '+imax+', '+Math.round((imax-imin)/2);
            if(ra < ratio) {
                imin = Math.round((imax-imin)/2);
            } else if(ra > ratio) {
                imax = Math.round((imax-imin)/2);
            } else {
                ir1 = Math.round((imax-imin)/2);ir2 = i;
                i=l;
                imin = imax;
            }
            alert(imax-min);
        }
        if(i!=l) {
            if(imax-imin == 3) {
                var ra = values[imin+1]/values[i];
                var p = Math.abs(ra-ratio);
                if(p<prc) {
                    prc = p;
                    ir1 = imin+1;ir2 = i;
                }
            } else {
                var ra = values[imin]/values[i];
                var p = Math.abs(ra-ratio);
                if(p<prc) {
                    prc = p;
                    ir1 = imin;ir2 = i;
                }
                ra = values[imax]/values[i];
                p = Math.abs(ra-ratio);
                if(p<prc) {
                    prc = p;
                    ir1 = imax;ir2 = i;
                }
            }
        }
    }
    */
    for(var i=0, l=values.length;i<l;i++) {
        for(var i2=0;i2<l;i2++) {
            var ra = values[i]/values[i2];
            var p = Math.abs(ra-ratio);
            if(p<prc) {
                prc = p;
                ir1 = i;
                ir2 = i2;
                if(p == 0)
                    break;
            }
        }
    }
    
    r = r1 = values[ir1];
    if(r < 1000) {
        document.getElementById('r1').value = r;document.getElementById('unite1').value = 0;
    } else {
        r = r/1000;
        if(r < 1000) {
            document.getElementById('r1').value = r;document.getElementById('unite1').value = 3;
        } else {
            r = r/1000;
            document.getElementById('r1').value = r;document.getElementById('unite1').value = 6;
        }
    }
    r = r2 = values[ir2];
    if(r < 1000) {
        document.getElementById('r2').value = r;document.getElementById('unite2').value = 0;
    } else {
        r = r/1000;
        if(r < 1000) {
            document.getElementById('r2').value = r;document.getElementById('unite2').value = 3;
        } else {
            r = r/1000;
            document.getElementById('r2').value = r;document.getElementById('unite2').value = 6;
        }
    }
    
    //document.getElementById('uout').value = Math.round(r2*toFloat(document.getElementById('ualim').value)*100/(r1+r2))/100;
}


function calcbcol()
{
	var r = 0;
    r = parseInt(document.getElementById('ann1').value);
    if(parseInt(document.getElementById('ann2').value) != -1) {
        r *= 10;
        r += parseInt(document.getElementById('ann2').value);
    }
    r *= Math.pow(10, parseInt(document.getElementById('ann_multi').value));
	
	set_color('bann1', parseInt(document.getElementById('ann1').value));
	set_color('bann2', parseInt(document.getElementById('ann2').value));
	set_color('bann_multi', parseInt(document.getElementById('ann_multi').value));
    
	r = Math.round(r*1000);
	
	if(r < 1000) {
        document.getElementById('res').value = r;document.getElementById('unite').value = -9;
    } else {
        r = r/1000;
        if(r < 1000) {
            document.getElementById('res').value = r;document.getElementById('unite').value = -6;
        } else {
            r = r/1000;
            if(r < 1000) {
                document.getElementById('res').value = r;document.getElementById('unite').value = -3;
            } else {
                r = r/1000;
                document.getElementById('res').value = r;document.getElementById('unite').value = 0;
            }
        }
    }
}

function bcalc_color()
{
	var r = toFloat(document.getElementById('res').value)*Math.pow(10, parseInt(document.getElementById('unite').value));
	// ! Color bands are in µH
	r = r*1e6*10;
	var tmpr = r;
	var nb1=0, nb2=0, nb3=0, nbmult=0, i=0;
	
	for(i=-2;i<10;i++)
	{
		if(tmpr < 10.0 && tmpr > 0.1)
		{
			tmpr = Math.floor(tmpr*100.0)/100.0;
			nb1 = Math.floor(tmpr);
			
			tmpr = (tmpr - nb1)*10.0 + 0.01;
			nb2 = Math.floor(tmpr);
			tmpr = Math.floor(tmpr*10.0)/10.0;
			
			tmpr = (tmpr - nb2)*10.0 + 0.1;
			nb3 = Math.floor(tmpr);
			
			nbmult = i;
			break;
		}
		tmpr = tmpr/10;
	}
	
	set_color('bann1', nb1);
	set_color('bann2', nb2);
	
	set_color('bann_multi', nbmult);
    
    document.getElementById('ann1').value = nb1;
    document.getElementById('ann2').value = nb2;
    document.getElementById('ann_multi').value = nbmult;
}

function calcrled()
{
	var r = 0;
	r = (toFloat(document.getElementById('valim').value.replace(',', '.'))-(toFloat(document.getElementById('vled').value.replace(',', '.'))*toFloat(document.getElementById('nbled').value.replace(',', '.'))))/(toFloat(document.getElementById('aled').value.replace(',', '.'))/1000);
	r = Math.round(r);
	
	if(r<0)
	{document.getElementById('r').innerHTML = '0 Ω<br/>Attention, Somme des tensions de chutes supérieures à la tension d\'alimentation';return;}
	
	if(r < 1000)
	{document.getElementById('r').innerHTML = r+' Ω';return;}
	
	r = r/1000;
	if(r < 1000)
	{document.getElementById('r').innerHTML = r+' kΩ';return;}
	r = r/1000;
	if(r < 1000)
	{document.getElementById('r').innerHTML = r+' MΩ';return;}
}

function calcrcol()
{
	var r = 0;
	if(document.getElementById('ann3').style.display == 'none')
	{
        r = parseInt(document.getElementById('ann1').value);
        if(parseInt(document.getElementById('ann2').value) != -1) {
            r *= 10;
            r += parseInt(document.getElementById('ann2').value);
        }
        r *= Math.pow(10, parseInt(document.getElementById('ann_multi').value));    
    }
	else
	{
        r = parseInt(document.getElementById('ann1').value);
        if(parseInt(document.getElementById('ann2').value) != -1) {
            r *= 10;
            r += parseInt(document.getElementById('ann2').value);
        }
        if(parseInt(document.getElementById('ann3').value) != -1) {
            r *= 10;
            r += parseInt(document.getElementById('ann3').value);
        }
        r *= Math.pow(10, parseInt(document.getElementById('ann_multi').value));
    }
	
	set_color('bann1', parseInt(document.getElementById('ann1').value));
	set_color('bann2', parseInt(document.getElementById('ann2').value));
	set_color('bann3', parseInt(document.getElementById('ann3').value));
	set_color('bann_multi', parseInt(document.getElementById('ann_multi').value));
    
    r = Math.round(r*1000)/1000;
	
	if(r < 1000) {
        document.getElementById('res').value = r;document.getElementById('unite').value = 0;
    } else {
        r = r/1000;
        if(r < 1000) {
            document.getElementById('res').value = r;document.getElementById('unite').value = 3;
        } else {
            r = r/1000;
            if(r < 1000) {
                document.getElementById('res').value = r;document.getElementById('unite').value = 6;
            } else {
                r = r/1000;
                document.getElementById('res').value = r;document.getElementById('unite').value = 9;
            }
        }
    }
}

function calc_color()
{
	var r = toFloat(document.getElementById('res').value)*Math.pow(10, parseInt(document.getElementById('unite').value));
	var tmpr = r*10;
	var nb1=0, nb2=0, nb3=0, nbmult=0, i=0;
	
	for(i=-2;i<10;i++)
	{
		if(tmpr < 10.0 && tmpr > 0.1)
		{
			tmpr = Math.floor(tmpr*100.0)/100.0;
			nb1 = Math.floor(tmpr);
			
			tmpr = (tmpr - nb1)*10.0 + 0.01;
			nb2 = Math.floor(tmpr);
			tmpr = Math.floor(tmpr*10.0)/10.0;
			
			tmpr = (tmpr - nb2)*10.0 + 0.1;
			nb3 = Math.floor(tmpr);
			
			nbmult = i;
			break;
		}
		tmpr = tmpr/10;
	}
	
	if(document.getElementById('bann3').style.display != 'none')
	{nbmult--;}
	
	if(r < 1.0 && document.getElementById('bann3').style.display != 'none')
	{nb3 = nb2;nb2 = nb1;nb1=0;}
	
	set_color('bann1', nb1);
	set_color('bann2', nb2);
	set_color('bann3', nb3);
	
	set_color('bann_multi', nbmult);
    
    document.getElementById('ann1').value = nb1;
    document.getElementById('ann2').value = nb2;
    document.getElementById('ann3').value = nb3;
    document.getElementById('ann_multi').value = nbmult;
}

function set_color(div, rcol)
{
	if(rcol < -1.5) {
		document.getElementById(div).style.backgroundColor = '#ccc';
	} else if(rcol < -0.5) {
		document.getElementById(div).style.backgroundColor = 'gold';
	} else if(rcol < 0.5) {
		document.getElementById(div).style.backgroundColor = 'black';
	} else if(rcol < 1.5) {
		document.getElementById(div).style.backgroundColor = '#783000';
	} else if(rcol < 2.5) {
		document.getElementById(div).style.backgroundColor = 'red';
	} else if(rcol < 3.5) {
		document.getElementById(div).style.backgroundColor = '#ff7800';
	} else if(rcol < 4.5) {
		document.getElementById(div).style.backgroundColor = 'yellow';
	} else if(rcol < 5.5) {
		document.getElementById(div).style.backgroundColor = 'green';
	} else if(rcol < 6.5) {
		document.getElementById(div).style.backgroundColor = 'blue';
	} else if(rcol < 7.5) {
		document.getElementById(div).style.backgroundColor = '#6f0059';
	} else if(rcol < 8.5) {
		document.getElementById(div).style.backgroundColor = '#888';
	} else {
		document.getElementById(div).style.backgroundColor = '#fff';
	}
}

function chnbann()
{
	if(document.getElementById('nbr2').checked == true)
    {
        document.getElementById('ann3').style.display = 'none';
        document.getElementById('bann3').style.display = 'none';
        document.getElementById('bann_or').style.marginLeft = '105px';
    }
	else
	{
        document.getElementById('ann3').style.display = 'inline';
        document.getElementById('bann3').style.display = 'block';
        document.getElementById('bann_or').style.marginLeft = '75px';
    }
	
	calcrcol();
	calc_color();
}

function toNumeric(sText){
	var ValidChars = "0123456789.";
	var Char;
	sText.replace(',', '.');
	var j=0;
	
	for (i=0; i < sText.length; i++)
	{
		Char = sText.charAt(i);
		if (ValidChars.indexOf(Char) == -1){
			sText = sText.substring(0, i)+sText.substring(i+1);
			i--;
		}
		j++;
		if(j==5)
		{break;}
	}
	
	if(sText.lenght <= 0 || sText == '')
	{sText = '0';}
	
	return sText;
}

function chnb()
{
	var nb = document.getElementById('nb').value;
	for(var i=1;i<10;i++)
	{
		if(i<=nb)
		{document.getElementById('allcomp'+i).style.display = 'inline';}
		else
		{document.getElementById('allcomp'+i).style.display = 'none';}
	}
}

function makeValueUnderstandable(val) {
	var j=0, ucv = '';
    
	while(val > 1000) {
		val = val/1000;
		j++;
	}
	switch(j) {
		case 1:
			ucv = 'k';break;
		case 2:
			ucv = 'M';break;
		case 3:
			ucv = 'G';break;
	}
	
	j=0;
	while(val < 1 && val != 0) {
		val = val*1000;
		j++;
	}
	switch(j)
	{
		case 1:
			ucv = 'm';break;
		case 2:
			ucv = 'µ';break;
		case 3:
			ucv = 'n';break;
		case 4:
			ucv = 'p';break;
	}
	
	if(val<10)
	{val = Math.round(val*100)/100;}
	else if(val<100)
	{val = Math.round(val*10)/10;}
	else
	{val = Math.round(val);}
    
    return val+' '+ucv;
}

function calcr() {
    var valcomp = 0, i2=0, u2=0, ptot=0;
	var mode = parseInt(document.getElementById('mode').value);
	var nb = parseInt(document.getElementById('nb').value);
	
	if(mode == 0)
	{
		for(var i=1;i<=nb;i++)
		{
            var res = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
            var p = eval(document.getElementById('pcomp'+i).value);
            
			valcomp += res;
            if(p/res < i2 || i==1)
                i2 = p/res;
		}
        for(var i=1;i<=nb;i++) {
            var res = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
            if(res != 0 && isFinite(i2))
                ptot += i2*res;
        }
	}
	else
	{
		for(var i=1;i<=nb;i++)
		{
            var res = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
			if(res == 0)
			{continue;}
            
            var p = eval(document.getElementById('pcomp'+i).value);
			valcomp += 1/(res);
            
            if(p*res < u2 || i==1)
                u2 = p*res;
		}
        for(var i=1;i<=nb;i++) {
            var res = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
            if(res != 0 && isFinite(u2))
                ptot += u2/res;
        }
		if(valcomp != 0)
		{valcomp = 1/valcomp;}
	}
	
	document.getElementById('valcomp').innerHTML = makeValueUnderstandable(valcomp)+'Ω';
    document.getElementById('pvalcomp').innerHTML = makeValueUnderstandable(ptot)+'W';
}

function calcb() {
    var valcomp = 0;
	var mode = parseInt(document.getElementById('mode').value);
	var nb = parseInt(document.getElementById('nb').value);
	
	if(mode == 0)
	{
		for(var i=1;i<=nb;i++)
		{
            var ind = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
			valcomp += ind;
		}
	}
	else
	{
		for(var i=1;i<=nb;i++)
		{
            var ind = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
			if(ind != 0)
			{valcomp += 1/(ind);}
		}
		if(valcomp != 0)
		{valcomp = 1/valcomp;}
	}
	
	document.getElementById('valcomp').innerHTML = makeValueUnderstandable(valcomp)+'H';
}


function calcc() {
    var valcomp = 0, umax=0;
	var mode = parseInt(document.getElementById('mode').value);
	var nb = parseInt(document.getElementById('nb').value);
	
	if(mode == 1)
	{
		for(var i=1;i<=nb;i++)
		{
            var cap = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
            var um = eval(document.getElementById('pcomp'+i).value);
            
			valcomp += cap;
            if(um < umax || i==1)
                umax = um;
		}
	}
	else
	{
		for(var i=1;i<=nb;i++)
		{
            var cap = toFloat(document.getElementById('comp'+i).value)*Math.pow(10, parseInt(document.getElementById('unite'+i).value));
			if(cap != 0)
			{
                valcomp += 1/cap;
                
                var um = eval(document.getElementById('pcomp'+i).value);
                umax += um;
            }
		}
		if(valcomp != 0)
		{valcomp = 1/valcomp;}
	}
	
	document.getElementById('valcomp').innerHTML = makeValueUnderstandable(valcomp)+'F';
    document.getElementById('uvalcomp').innerHTML = makeValueUnderstandable(umax)+'V';
}
